=== debian/changelog ===
perl (5.8.8-7) unstable; urgency=low

  * Apply optimisation for File::Spec->abs2rel suggested by joeyh
    (closes: #376658).

  * Patch perl5db.pl to cope with lines from a remote socket requiring
    multiple calls to recv (fixes a problem reported by EPIC folks).

  * Merge NMU.

  [Marc 'HE' Brockschmidt] (closes: #398331)
  * Completly replace libnet-perl:
   + Integrate some patches for the Net:: modules
   + debian/control: Update to replace the last libnet-perl version.
   + Update configuration mechanism so that /etc/perl/Net/libnet.cfg
     sources in /etc/libnet.cfg if it exists, otherwise the
     configuration is stored there. This saves us trouble from
     converting debconf-managed /etc/libnet.cfg to a dpkg conffile

 -- Brendan O'Dea <bod@debian.org>  Sun, 19 Nov 2006 01:07:26 +1100

perl (5.8.8-6.1) unstable; urgency=high

  * Non-maintainer upload to fix Failure To Build From Source in hppa, mips
    and mipsel architectures.
  * Added debian/patches/74_debian_hppa_mips_optim, that forces pp_pack.c to
    be compiled without the delayed-branch optimization option.
    (Closes: #374396)

 -- Margarita Manterola <marga@debian.org>  Sun,  6 Aug 2006 11:50:18 -0300

perl (5.8.8-6) unstable; urgency=low

  * Work around g++-4.1 issue with register parameter declarations.
  * Add errno.ph (simple wrapper around Errno module).

 -- Brendan O'Dea <bod@debian.org>  Sun, 11 Jun 2006 22:38:12 +1000

perl (5.8.8-5) unstable; urgency=low

  * Correctly identify arch-specific modules in ext/ where the .pm
    files are under lib.  Adjust perl-base.files (closes: #369481).

  * Ensure that POSIX/SigAction is kept with the rest of the POSIX
    module under archlib.

  * Apply upstream change 26536: add INSTALL{VENDOR,SITE}SCRIPT
    macros (closes: #362949).

  * [Don Armstrong] Revert part of upstream change 24524 to always use
    PERLRUNINST when building perl modules (closes: #357264).

 -- Brendan O'Dea <bod@debian.org>  Sat,  3 Jun 2006 17:06:45 +1000

perl (5.8.8-4) unstable; urgency=low

  * Preserve timestamps in /usr/share/doc.
  * Revert Sys::Syslog change (see: #345157).
  * Fix typo in perlsec(1) (closes: #358455).
  * Change build-dep on procps to "procps|hurd" (closes: #357699).

 -- Brendan O'Dea <bod@debian.org>  Wed,  5 Apr 2006 01:30:11 +1000

perl (5.8.8-3) unstable; urgency=low

  * Add build-dep on procps (required by t/op/magic).
  * Remove trailing \0 from Sys::Syslog messages (closes: #345157).
  * Getopt::Long:  allow "ignorecase_always" as a synonym for
    "ignore_case_always" to match the documention (closes #354197).

  * Don't add -Wdeclaration-after-statement to ccflags: this causes
    problems when building extensions with gcc-3.3 .

  * Pod::Man: don't translate "|" (closes: #291391).

 -- Brendan O'Dea <bod@debian.org>  Fri, 10 Mar 2006 03:07:28 +1100

perl (5.8.8-2) unstable; urgency=low

  * Move overload.pm back to perl-base (closes: #352060).
  * Extend timer in Time::HiRes test to 5 mins (for m68k).

 -- Brendan O'Dea <bod@debian.org>  Fri, 10 Feb 2006 06:23:17 +1100

perl (5.8.8-1) unstable; urgency=low

  * New upstream version.
  * Update perl-base conflict versions for:
      libscalar-list-utils-perl (1.18).

  * Update perl conflict versions for:
      libdigest-md5-perl (2.36),
      libmime-base64-perl (3.07),
      libstorable-perl (2.15) and
      libtime-hires-perl (1.86).

  * Update perl-modules conflict versions for:
      libattribute-handlers-perl (0.78_02),
      libcgi-pm-perl (3.15),
      libpod-parser-perl (1.32),
      libansicolor-perl (1.10),
      libtest-harness-perl (2.56) and
      libtest-simple-perl (0.62).

  * Revert debian/patches/02_fix_file_path to upstream fix.
  * Update to DB_File to db4.4.
  * Move Data::Dumper and overload from perl-base to perl now that
    debconf no longer requires Data::Dumper.

 -- Brendan O'Dea <bod@debian.org>  Sat,  4 Feb 2006 19:33:24 +1100

perl (5.8.7-10) unstable; urgency=low

  * Remove DB_File version checks (closes: #340047, #343335).
  * Remove Errno version check, which can cause problems with long-running
    processes that embed perl when perl is upgraded (closes: #343351)

  * Apply upstream 26321: Disallow sprintf's vector handling for
    non-integer formats.

 -- Brendan O'Dea <bod@debian.org>  Fri, 16 Dec 2005 01:32:14 +1100

perl (5.8.7-9) unstable; urgency=high

  * SECURITY [CVE-2005-3962] (closes: #341542):
    + Apply upstream fixes to prevent buffer overflows in
      printf/sprintf caused by malicious format strings.
    + Update Sys::Syslog to 0.09, which only uses the message as a
      format string to sprintf when additional arguments are given.

  * Remove -Dusemymalloc from perl-debug (added for #178243: to
    enable PERL_DEBUGGING_MSTATS), as this causes debugperl to break with
    compiled modules.  Closes: #337050, #342526).

  * Skip Math::Complex tests 267 and 487, failing due to non-IEEE fp
    rounding rules in the kernel fp emulation.

 -- Brendan O'Dea <bod@debian.org>  Sat, 10 Dec 2005 16:43:02 +1100

perl (5.8.7-8) unstable; urgency=low

  * ARM fix is also required for armeb.
  * Skip lib/Net/hostent.t test if no /etc/hosts (some buildds).
  * Fix debugger termination message to refer to "o" rather than "O" for
    setting options (closes: #334516).

  * Fix problem with untainting of captured $N (thanks to Chris Heath
    for analysis and patch; closes: #303308).

  * Fix h2ph to correctly locate gcc's include directory (closes: #328500).
  * Update to DB_File to db4.3 (closes: #336486).

 -- Brendan O'Dea <bod@debian.org>  Sun, 13 Nov 2005 12:05:29 +1100

perl (5.8.7-7) unstable; urgency=low

  * ARM optimisation fix take 2.  Downgrade optimisation of pp_pack to
    -Os (closes:  #333510).  Thanks to Bill Gatliff for the extended
    use of the CSB625 is his basement.

  * Change section of perl-base to "perl".

 -- Brendan O'Dea <bod@debian.org>  Mon, 17 Oct 2005 23:16:32 +1000

perl (5.8.7-6) unstable; urgency=low


