=== debian/control ===
Source: perl
Section: perl
Priority: standard
Maintainer: Brendan O'Dea <bod@debian.org>
Standards-Version: 3.6.2
Build-Depends: file, cpio (>= 2.6-5), libdb4.4-dev, libgdbm-dev, netbase [!hurd-i386], gcc (>= 4:4.0), procps | hurd

Package: perl-base
Essential: yes
Priority: required
Architecture: any
Pre-Depends: ${shlibs:Depends}
Conflicts: perl-5.004-base (<< 6), perl-5.005-base (<< 6), perl-5.6-base (<< 6), autoconf2.13 (<< 2.13-45), libscalar-list-utils-perl (<< 1:1.18-1)
Replaces: perl-5.005-base (<< 6), perl-5.6-base (<< 6), perl (<< 5.8.8-5), perl-modules (<< 5.8.8-2), libperl5.8 (<< 5.8.0-20), libscalar-list-utils-perl, libclass-multimethods-perl (<< 1.70-4)
Provides: perl5-base, ${perlapi:Provides}, libscalar-list-utils-perl
Suggests: perl
Description: The Pathologically Eclectic Rubbish Lister
 A scripting language with delusions of full language-hood, Perl is used
 in many system scripts and utilities.
 .
 This is a stripped down Perl with only essential libraries.  To make
 full use of Perl, you'll want to install the `perl', `perl-modules' and
 optionally `perl-doc' packages which supplement this one.

Package: libcgi-fast-perl
Priority: optional
Architecture: all
Depends: perl (>= ${Source-Version}), libfcgi-perl
Description: CGI::Fast Perl module
 CGI::Fast is a subclass of the CGI object created by CGI.pm.  It is
 specialized to work well with the Open Market FastCGI standard, which
 greatly speeds up CGI scripts by turning them into persistently running
 server processes.  Scripts that perform time-consuming initialization
 processes, such as loading large modules or opening persistent database
 connections, will see large performance improvements.

Package: perl-doc
Section: doc
Priority: optional
Architecture: all
Depends: perl (>= ${Upstream-Version}-1)
Conflicts: perl-5.004-doc (<< 6), perl-5.005-doc (<< 6), perl-5.6-doc (<< 6)
Replaces: perl-5.005-doc (<< 6), perl-5.6-doc (<< 6)
Suggests: man-browser, groff
Description: Perl documentation
 Perl manual pages, POD documentation and the `perldoc' program.  If you are
 writing Perl programs, you almost certainly need this.

Package: perl-modules
Priority: standard
Architecture: all
Depends: perl (>= ${Upstream-Version}-1)
Conflicts: libpod-parser-perl (<< 1.32-1), libansicolor-perl (<< 1.10-1), libfile-temp-perl (<< 0.16-1), libnet-perl (<= 1:1.19-3), libattribute-handlers-perl (<< 0.78_02-1), libcgi-pm-perl (<< 3.15-1), libi18n-langtags-perl (<< 0.35-1), liblocale-maketext-perl (<< 1.08-1), libmath-bigint-perl (<< 1.77-1), libnet-ping-perl (<< 2.31-1), libtest-harness-perl (<< 2.56-1), libtest-simple-perl (<< 0.62-1), liblocale-codes-perl (<< 2.06.1-1)
Replaces: libpod-parser-perl, libansicolor-perl, libfile-temp-perl, libnet-perl, libattribute-handlers-perl, libcgi-pm-perl, libi18n-langtags-perl, liblocale-maketext-perl, libmath-bigint-perl, libnet-ping-perl, libtest-harness-perl, libtest-simple-perl, liblocale-codes-perl
Provides: libpod-parser-perl, libansicolor-perl, libfile-temp-perl, libnet-perl, libattribute-handlers-perl, libcgi-pm-perl, libi18n-langtags-perl, liblocale-maketext-perl, libmath-bigint-perl, libnet-ping-perl, libtest-harness-perl, libtest-simple-perl, liblocale-codes-perl
Description: Core Perl modules
 Architecture independent Perl modules.  These modules are part of Perl and
 required if the `perl' package is installed.

Package: perl-debug
Priority: optional
Architecture: any
Depends: perl (= ${Source-Version}), ${shlibs:Depends}
Conflicts: perl-5.004-debug (<< 6), perl-5.005-debug (<< 6), perl-5.6-debug (<< 6)
Replaces: perl-5.005-debug (<< 6), perl-5.6-debug (<< 6)
Description: Debug-enabled Perl interpreter
 debugperl provides a debug-enabled version of Perl which can produce
 extensive information about the interpreter as it compiles and executes
 a program (see the -D switch in perlrun(1)).
 .
 Note that this package is primarily of use in debugging *Perl* rather
 than perl programs, which may be traced/debugged using the standard
 perl binary using the -d switch (see perldebug(1)).

Package: perl-suid
Priority: optional
Architecture: any
Depends: perl (= ${Source-Version}), ${shlibs:Depends}
Conflicts: perl-5.004-suid (<< 6), perl-5.005-suid (<< 6), perl-5.6-suid (<< 6)
Replaces: perl-5.005-suid (<< 6), perl-5.6-suid (<< 6)
Description: Runs setuid Perl scripts
 suidperl is a setuid root helper program which is invoked by perl when
 executing scripts with setuid/gid bits set on systems (like linux) which
 don't have support setuid script execution natively in the kernel.
 .
 Usage of this program is now strongly deprecated upstream and support
 (along with this package) will probably be removed in 5.10.

Package: libperl5.8
Section: libs
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, perl-base (= ${Source-Version})
Conflicts: libapache-mod-perl (<< 1.29.0.1-3)
Replaces: perl-base (<= 5.8.7-4)
Description: Shared Perl library
 This package is required by programs which embed a Perl interpreter to
 ensure that the correct version of `perl-base' is installed.  It
 additionally contains the shared Perl library on architectures where the
 perl binary is linked to libperl.a (currently only i386, for performance
 reasons).  In other cases the actual library is in the `perl-base' package.

Package: libperl-dev
Section: libdevel
Priority: optional
Architecture: any
Depends: perl (= ${Source-Version}), libperl5.8 (= ${Source-Version})
Description: Perl library: development files
 Files for developing applications which embed a Perl interpreter and for
 programs compiled with perlcc.

Package: perl
Priority: standard
Architecture: any
Depends: perl-base (= ${Source-Version}), perl-modules (>= ${Source-Version}), ${shlibs:Depends}
Conflicts: data-dumper, perl-5.004 (<< 6), perl-5.005 (<< 6), perl-5.6 (<< 6), perl-doc (<< ${Upstream-Version}-1), libdigest-md5-perl (<< 3.07-1), libmime-base64-perl (<< 3.07-1), libtime-hires-perl (<< 1.86-1), libstorable-perl (<< 2.15-1)
Replaces: perl-base (<< 5.8.8-1), perl-5.005 (<< 6), perl-5.6 (<< 6), perl-doc (<< 5.8.0-1), perl-modules (<< 5.8.1-1), libdigest-md5-perl, libmime-base64-perl, libtime-hires-perl, libstorable-perl 
Provides: data-dumper, perl5, libdigest-md5-perl, libmime-base64-perl, libtime-hires-perl, libstorable-perl 
Recommends: perl-doc
Suggests: libterm-readline-gnu-perl | libterm-readline-perl-perl
Description: Larry Wall's Practical Extraction and Report Language
 An interpreted scripting language, known among some as "Unix's Swiss
 Army Chainsaw".
 .
 Perl is optimised for scanning arbitrary text files and system
 administration.  It has built-in extended regular expression matching
 and replacement, a data-flow mechanism to improve security with
 setuid scripts and is extensible via modules that can interface to C
 libraries.
